<?php

namespace App\ArgumentResolver;

use App\Request\DatatableRequest;
use Symfony\Component\DependencyInjection\Attribute\AutoconfigureTag;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Controller\ValueResolverInterface;
use Symfony\Component\HttpKernel\ControllerMetadata\ArgumentMetadata;

/**
 * A value resolver for {@see DatatableRequest}
 */
#[AutoconfigureTag('controller.argument_value_resolver', ['priority' => 110])]
class DatatableRequestArgumentResolver implements ValueResolverInterface {
    /**
     * @inheritDoc
     */
    public function resolve (Request $request, ArgumentMetadata $argument): iterable {
        //region Check if parameter is supported (
        if ($argument->getType() !== DatatableRequest::class) {
            return [];
        }
        //endregion

        return [new DatatableRequest($request)];
    }
}