<?php

namespace App\Controller\Administration;

use App\Request\DatatableRequest;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;
use Symfony\Contracts\Translation\TranslatorInterface;

/**
 * Controllers for users administration pages
 */
#[Route('/admin/user')]
class UserController extends AbstractController {
    /**
     * @var TranslatorInterface The translator service
     */
    private readonly TranslatorInterface $translator;

    /**
     * Initialisation
     *
     * @param TranslatorInterface $translator The translator service
     */
    public function __construct (TranslatorInterface $translator) {
        $this->translator = $translator;
    }

    /**
     * List all users
     *
     * @return Response The response
     */
    #[Route('/', name: 'admin_user_list')]
    public function list (): Response {
        return $this->render('/Administration/user/list.html.twig');
    }
    /**
     * AJAX query for a list of users (Datatables.net)
     *
     * @return Response The response
     */
    #[Route('/ajax', name: 'admin_user_ajax', methods: 'POST')]
    public function list__ajax (DatatableRequest $request): Response {
        ///TODO
        return $this->render('/Administration/user/list.html.twig');
    }
}
